Vue.component('cost-checkbox', {
    props: ['args', 'total', 'id', 'labels', 'calc'],
    data: function () {
        return {
            label: '',
            alias: '',
            classes: '',
            checkboxes: '',
            description: '',
            checkboxValue: [],
            labelFor: 'option',
        }
    },

    created() {
        let vm = this;
        if (vm.args) {
            vm.alias = vm.args.alias;
            vm.classes = vm.args.additionalStyles;
            vm.label = vm.args.label ? this.args.label : '';
            vm.checkboxes = vm.args.options ? vm.args.options : '';
            vm.description = vm.args.hasOwnProperty('description') ? vm.args.description : '';
        }
    },

    methods: {
        changed: function (event) {
            let vm = this;
            if (event.target.checked) {
                vm.checkboxValue.push(parseFloat(event.target.value));
            } else {
                vm.checkboxValue.forEach(function (element, index) {
                    if (parseInt(element) === parseInt(event.target.value))
                        vm.checkboxValue.splice(index, 1);
                });
            }

            vm.$emit('change', vm.checkboxValue, vm.total, vm.id, vm.alias)
        }
    },

    template: `<div class="ccb-inner-wrapper">
                  <label :style="labels">{{label}}:</label>
                  <template v-for="(item, index) in checkboxes" :key="index">
                     <input  type="checkbox" :id="labelFor + index + '_calc_id_' + calc" type="checkbox"  :value="item.optionValue" @change="changed">
                     <label class="light" :for="labelFor + index + '_calc_id_' + calc" :class="classes">{{item.optionText}}</label><br>
                  </template>
                  <p class="ccb-inner-description"><small>{{description}}</small></p>
              </div>
              `,
});