(function ($) {
    Vue.component('cost-drop-down', {
        props: ['args', 'total', 'id', 'labels', 'calc'],
        data: function () {
            return {
                alias: '',
                label: '',
                classes: '',
                options: null,
                description: '',
                selectValue: '',
                label_id: 'ccb_label',
            }
        },

        created() {
            let vm = this;
            if (vm.args) {
                vm.alias = vm.args.alias;
                vm.classes = vm.args.additionalStyles;
                vm.label = vm.args.label ? vm.args.label : '';
                vm.label_id += '_' + vm.id + '_calc_id_' + vm.calc;
                vm.options = vm.args.options ? vm.getOptions(vm.args.options) : '';
                vm.description = vm.args.hasOwnProperty('description') ? vm.args.description : '';
                vm.selectValue = vm.args.default && parseFloat(vm.args.default) ? parseFloat(vm.args.default) : '';
            }
        },

        mounted() {
            if (jQuery.fn.select2) {
                this.listeningForSelect2();
            }
        },

        methods: {
            getOptions: function (options) {

                let readyOptions = '<optgroup label="' + this.label + '">';

                for (let optionCount in options) {
                    let value = parseInt(options[optionCount].optionValue) ? options[optionCount].optionValue : 0;
                    readyOptions += '<option value="' + value + '">' + options[optionCount].optionText + '</option>';
                }

                readyOptions += '<optgroup>';
                return readyOptions;
            },

            listeningForSelect2: function () {
                let vm = this;
                $('#' + vm.label_id).on('select2:select', function (e) {
                    let selectedVal = $(this).select2('val');
                    vm.$emit('change', selectedVal, vm.total, vm.id, vm.alias);
                });
            },
        },

        template: ` <div class="ccb-inner-wrapper">
                        <label :style="labels">{{label}}:</label>
                        <select :id="label_id" v-model="selectValue" v-on:change="$emit(\'change\', selectValue, total, id, alias)" v-html="options"></select>
                        <p class="ccb-inner-description"><small>{{description}}</small></p>
                    </div>
              `,
    });
})(jQuery);